<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------


namespace app\adminapi\controller\master_worker;


use app\adminapi\controller\BaseAdminController;
use app\adminapi\lists\master_worker\MasterWorkerInfoLists;
use app\adminapi\logic\master_worker\MasterWorkerInfoLogic;
use app\adminapi\validate\master_worker\MasterWorkerInfoValidate;
use app\common\logic\MasterWorkerExamineLogic;


/**
 * MasterWorkerInfo控制器
 * Class MasterWorkerInfoController
 * @package app\adminapi\controller\master_worker
 */
class MasterWorkerInfoController extends BaseAdminController
{


    /**
     * @notes 获取列表
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/10/07 18:58
     */
    public function lists()
    {
        return $this->dataLists(new MasterWorkerInfoLists());
    }


    /**
     * @notes 添加
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/10/07 18:58
     */
    public function add()
    {
        $params = (new MasterWorkerInfoValidate())->post()->goCheck('add');
        $result = MasterWorkerInfoLogic::add($params);
        if (true === $result) {
            MasterWorkerExamineLogic::updateEngineerInformation($params['worker_id']);
            return $this->success('添加成功', [], 1, 1);
        }
        return $this->fail(MasterWorkerInfoLogic::getError());
    }


    /**
     * @notes 编辑
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/10/07 18:58
     */
    public function edit()
    {
        $params = (new MasterWorkerInfoValidate())->post()->goCheck('edit');
        $result = MasterWorkerInfoLogic::edit($params);
        if (true === $result) {
            $info = MasterWorkerInfoLogic::detail(['id'=>$params['id']]);
            MasterWorkerExamineLogic::updateEngineerInformation($info['worker_id']);
            return $this->success('编辑成功', [], 1, 1);
        }
        return $this->fail(MasterWorkerInfoLogic::getError());
    }


    /**
     * @notes 删除
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/10/07 18:58
     */
    public function delete()
    {
        $params = (new MasterWorkerInfoValidate())->post()->goCheck('delete');
        $worker_ids = MasterWorkerInfoLogic::getWorkerIds($params);
        MasterWorkerInfoLogic::delete($params);
        foreach ($worker_ids as $worker_id) {
            MasterWorkerExamineLogic::updateEngineerInformation($worker_id);
        }
        return $this->success('删除成功', [], 1, 1);
    }


    /**
     * @notes 获取详情
     * @return \think\response\Json
     * @author likeadmin
     * @date 2024/10/07 18:58
     */
    public function detail()
    {
        $params = (new MasterWorkerInfoValidate())->goCheck('detail');
        $result = MasterWorkerInfoLogic::detail($params);
        return $this->data($result);
    }


}